<Tooltip value={name}>
  <ContextMenu choices={contextChoices} hide={!id}>
    <div class="guild-selector"
         class:no-grow="outline"
         class:outlined="outline"
         class:selected="$guildId && $guildId === id"
         style={iconUrl ? `background-image:url(${iconUrl})`
     : undefined} on:click="onClick(id)">
      <div class="hover-box">
        <slot />
      </div>
    </div>
  </ContextMenu>
</Tooltip>

<script>
  import Tooltip from "./Tooltip.svelte";
  import ContextMenu from "./ContextMenu.svelte";
  import RestClient from "../js/RestClient";
  import GuildStore from "../stores/GuildStore";
  import GuildSettingsModal from "./modals/GuildSettingsModal.svelte";
  import env from "../js/constants";
  import NicknameModal from "./modals/NicknameModal.svelte";

  export default {
    components: {
      Tooltip,
      ContextMenu
    },
    computed: {
      iconUrl({icon, id}) {
        return id && icon ? `${env.API_BASE}/icons/${id}` : null;
      }
    },
    oncreate() {
      this.set({
        contextChoices: [
          {
            text: "Edit Guild",
            click: async () => {
              this.store.set({
                modal: {
                  component: GuildSettingsModal,
                  options: GuildStore.getGuild(this.get().id)
                }
              });
            }
          },
          {
            text: "Change Nickname",
            click: async () => {
              const got = this.get();
              const storeGot = this.store.get();
              this.store.set({
                modal: {
                  component: NicknameModal,
                  options: {
                    guildId: got.id,
                    // we need to get MemberStore to track data on nicknames / usernames
                    nickname: "Not implemented",
                    userId: storeGot.userId
                  }
                }
              });
            }
          },
          {
            text: "Leave Guild",
            click: async () => {
              const {id} = this.get();
              await RestClient.post(`/guilds/${id}/leave`);
              GuildStore.unslurp({id});
            },
            color: "#b03"
          },
          {
            text: "Copy ID",
            click: () => alert(this.get().id)
          }
        ]
      });
    },
    methods: {
      onClick(id) {
        if (id) this.store.setChannel(id);
        else this.fire("click");
      }
    }
  };
</script>

<style>
  .guild-selector {
    width: 50px;
    height: 50px;
    background: #4b4f52;
    margin: 8px;
    border-radius: 100%;
    transition: border-radius 0.25s;
    cursor: pointer;
    background-size: cover;
  }
  .guild-selector.selected {
    cursor: default;
  }
  .guild-selector.selected:not(.no-grow),
  .guild-selector:not(.no-grow):hover {
    border-radius: 30%;
  }

  .guild-selector.outlined {
    border: dashed 2px #868686;
    width: 46px;
    height: 46px;
    transition: border-color 0.25s ease-in-out;
  }
  .guild-selector.outlined:hover {
    border-color: #ccc;
  }

  .guild-selector.selected .hover-box,
  .guild-selector:hover .hover-box {
    color: #ccc;
  }

  .hover-box {
    transition: color 0.25s ease-in-out;
    text-align: center;
    color: #868686;
    line-height: 46px;
    font-size: 3em;
    font-weight: 200;
    font-family: serif;
  }
</style>
